import Keyboard;

/**
 * Classe Avalia,  onde vai ser feito o clculo da expresso Posfixa
 *
 * @created 04/06/2002
 * @version 04/06/2002
 * @author Fernando Seiji Muramatsu	
 * @author Glaciel Ozorio Siqueira
 */


class Avalia 
{
   private char x;
   private char t;
   private double y;
   private double z;
   private double valor;
   double w;
   
   /**
   *
   * Mtodo Avaliador, tendo como parametros de entrada char exPosfixa[] e int j.
   * Sendo a exPosfixa[] uma array de char e int o tamanho da espresso Posfixa.
   *
   */
   
   
   public void avaliador(char exPosfixa[], int j) 
   {
      
      PilhaDouble pilhaDouble = new PilhaDouble();
      pilhaDouble.construtor(225);
      int tamanhoMaxPosfixa = j + 1;
     
      
      for(int i = 0; i <= tamanhoMaxPosfixa - 1; i++) 
      {
         
         /**
         *
         * a varivel x recebe o primeiro elemento da expresso Posfixa 
         *
         */
         
         x = exPosfixa[i];
            
            /**
            *
            * se a varivel x for A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,X,W,Y,Z 
            * ento a varivel valor recebe um valor e coloca esse valor na pilhaDouble
            *
            */
            
            if((x >= 'A' && x <='Z')) 
            {
    		   	valor = Keyboard.readDouble("Digite o valor de "+x+ " = ");
               	pilhaDouble.colocar(valor);	
            	
            			
            }
            
            /**
            *
            * Se a varivel x for !, resolve - se o fatorial e coloca na pilhaDouble o
            * valor dessa fatorial.
            *
            */
            
            
            if(x == '!') 
            {
            
            	double fatorial = 1;
            	for(double cont = valor; cont >= 1; cont--) {
            		
            		fatorial = fatorial * cont;
            		
            	}
            
            	pilhaDouble.colocar(fatorial);
            
            }		
            
            /**
            *
            * Se a varivel x for +,-,*,/,^ retira da pilha o valor que esta no topo da
            * pilhaDouble e coloca na varivel y. Depois ele retira novamente o valor 
            * que esta no topo da pilhaDouble e coloca na varivel y.
            *
            */
            
            if ((x == '+') || (x == '-') || (x == '*') || (x == '/') || (x == '^')) 
            {
            
               y = pilhaDouble.retira();
               z = pilhaDouble.retira();
               
            }
            
            /**
            *
            * Aqui no switch em cada caso ele realiza a operao corresondente a x e 
            * coloca esse valor no topo da pilhaDouble.
            *
            *
            */
            
            
            switch(x) 
            {
                  
                 case '+' : pilhaDouble.colocar(z+y);
                 break;
                 case '-' : pilhaDouble.colocar(z-y);
                 break;
                 case '*' : pilhaDouble.colocar(z*y);
                 break; 
                 case '/' : pilhaDouble.colocar(z/y);
                 break;
                 case '^' : pilhaDouble.colocar(Math.pow(z,y));  // para calcular expoente
                 break;                 
								 	            
            }   
            
      }
      
      /**
      *
      * Retira - se o valor da pilhaDouble e coloca na varivel w. Depois imprimir o valor
      * da expresso posfixa na tela.
      * 
      */
      
      w = pilhaDouble.retira();
      System.out.println("O resultado da expressao Posfixa = " + w);
      
   }
      
}     
