/**
 * Classe PilhaDouble, onde fica armazenados os dados de tipo double
 *
 * @created 04/06/2002
 * @version 04/06/2002
 * @author Fernando Seiji Muramatsu	
 * @author Glaciel Ozorio Siqueira
 */

class PilhaDouble {
   
   double[] vetor = new double[255];   
   int topo;                          
   private int t;                     
   private double x;
   
   /**
   *
   * Mtodo Contrutor, onde recebe como parametro o tamanho da expresso Posfixa
   *
   */
   
   public void construtor(int tamanhoMaxPosfixa) {    
      
      topo = -1;                 
      t = tamanhoMaxPosfixa;               
   }  
   
   /**
   *
   * Mtodo Vazia,  encarregado de verificar se a pilha est ou no vazia. Retornando 
   * true em caso de vazia e false em caso contrrio
   *
   */
   
   public boolean vazia() {
      
      boolean ok;
      
      if( topo == -1 ) {
         
         ok = true;
         
      }
      
      else { 
      
         ok = false;
         
      }
      
      return ok;
      
   }
   
   
   /**
   *
   * Mtodo Colocar, tem como parametro de entrada o valor double de x, e fica  
   * encarregado de colocar na pilha o valor double de x. Retornando true quando foi  
   * colocado o na pilha com sucesso ou false em caso contrrio.
   *
   */
   
   public boolean colocar(double x) {
      
      boolean ok = false;
      if(topo + 1 < t) {
         
         topo = topo + 1;
         vetor[topo] = x;
         ok = true;
      }
      
      return ok;
   }
   
   /**
   *
   * Mtodo Retira, esse mtodo fica encarregado de retirar o elemento que est no topo 
   * da pilha. Retornando esse valor double.
   *
   */
   
   public double retira() {
      
      if(!vazia()) {
            
         x = vetor[topo];
         topo = topo - 1;
      
      }
      
      return x;
      
   }
   
   /**
   *
   * Mtodo Acessa,  encarregado de acessar o topo da pilha. Retornando esse valor 
   * double.
   *
   */
   
   public double acessa() {
      
      if(!vazia()) {
         
         x = vetor[topo];  
      
      }  
         
      return x;
   
   }



}


