/**
 * Classe Pilha, onde fica armazenados os dados de tipo char
 *
 * @created 04/06/2002
 * @version 04/06/2002
 * @author Fernando Seiji Muramatsu	
 * @author Glaciel Ozorio Siqueira
 */


class Pilha {
	
	char[] vetor = new char[255]; 
	Prioridade prioridade = new Prioridade();      
	int topo;
	char w;					            
	private int t;						      
	private char x;
	
	 /**
      *
      * Mtodo Contrutor, onde recebe como parametro o tamanho da expresso Infixa
      *
      */
	
	public void construtor(int tamanhoMaxInfixa) {		
		
		topo = -1;						         
		t = tamanhoMaxInfixa;					
	}	
	
	/**
    *
    * Mtodo Vazia,  encarregado de verificar se a pilha est ou no vazia. Retornando 
    * true em caso de vazia e false em caso contrrio
    *
    */
	
	public boolean vazia() {
		
		boolean ok;
		
		if( topo == -1 ) {
			
			ok = true;
			
		}
		
		else { 
		
			ok = false;
			
		}
		
		return ok;
		
	}
	
	/**
    *
    * Mtodo Colocar, tem como parametro de entrada o valor char de x, e fica encarregado 
    * de colocar na pilha o valor double de x. Retornando true quando foi colocado o na 
    * pilha com sucesso ou false em caso contrrio.
    *
    */
	
	
	public boolean colocar(char x) {
		
		boolean ok = false;
		if(topo + 1 < t) {
			
			topo = topo + 1;
			vetor[topo] = x;
			ok = true;
		}
		
		return ok;
	}
	
	/**
    *
    * Mtodo Retira, esse mtodo fica encarregado de retirar o elemento que est no topo 
    * da pilha. Retornando esse valor char.
    *
    */
	
	public char retira() {
		
		if(!vazia()) {
				
			x = vetor[topo];
			topo = topo - 1;
		
		}
		
		return x;
		
	}
	
	/**
    *
    * Mtodo Acessa,  encarregado de acessar o topo da pilha. Retornando esse valor 
    * char.
    *
    */
	
	public char acessa() {
		
		if(!vazia()) {
			
			x = vetor[topo];
			w = prioridade.operador(x);	
		
		}	
			
		return w;
	
	}



}


